## 2013-NOV-09
## lg_Dn.R

if(FALSE){
cmfit2 <- iprior(eqns=lc2) # xtms2eqns is not ok
cmfit3 <- iprior(eqns=lc3) # xtms2eqns is ok
cmfit4 <- iprior(circle=lc4) # xtms2eqns is ok

cxtms <- do.call(rbind, cmfit4$xtms)
cxtms <- cxtms[chull(cxtms),]
cxtms <- as.list(as.data.frame(t(cxtms)))
xtms2eqns(obj=cxtms, show=TRUE)
}

rm(list=ls())
library(ipeglim)

set.seed(18372342)
y <- rvg4yx(N=20, pars=2, ztrunc=FALSE, xreg=FALSE, kind="poisson")$y
table(y)
m2fit <- model(formula=y~0, ztrunc=FALSE, dist="poisson", verbose=FALSE)

# scenarios
lc1 <- list(lhs=rbind(diag(rep(1,2)), diag(rep(-1,2))), rhs=c(0,0,-10,-10))
lc2 <- list(lhs=rbind(diag(rep(1,2)), diag(rep(-1,2)), c(-1,1)), rhs=c(1,1,-8,-8,-4))
lc3 <- list(lhs=rbind(c(1,1), c(-1,-1), c(-1,1), c(1,-1), c(0,-1), c(0,1)), rhs=c(3,-7,-3,-1,-3,1)*2)
lc4 <- list(x=5,y=5,r=5,len=25)

# source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/xtms2eqns.R")
cmfit1 <- iprior(obj=m2fit, eqns=lc1, verbose=FALSE)
# cmfit1 <- set.grid(obj=cmfit1, len=10) # xtms2eqns is not ok
cmfit2 <- iprior(obj=m2fit, eqns=lc2, verbose=FALSE)
cmfit3 <- iprior(obj=m2fit, eqns=lc3, verbose=FALSE)
cmfit4 <- iprior(obj=m2fit, circle=lc4, verboser=FALSE)

# source("~/Documents/PhD/ipeglim/pkg/ipeglim/R/plot_imprecise.R")

sop1 <- summary(update(obj=cmfit1, method="AS", apriori="lgamma", silent=TRUE), silent=TRUE)
sop2 <- summary(update(obj=cmfit2, method="AS", apriori="lgamma", silent=TRUE), silent=TRUE)
sop3 <- summary(update(obj=cmfit3, method="AS", apriori="lgamma", silent=TRUE), silent=TRUE)
sop4 <- summary(update(obj=cmfit4, method="AS", apriori="lgamma", silent=TRUE), silent=TRUE)

if(FALSE){

par(mfrow=c(2,2), mar=c(4,4,0,0))
z <- range(sop1$est)
z.mar <- 0.2
zlim <- c(z[1]-z.mar, z[2]+z.mar)
xlim <- ylim <- c(-1,11)
plot(sop1, zlim=zlim, xlim=xlim, ylim=ylim, main="Scenario 1", 
     xlab=expression(alpha), ylab=expression(beta), 
     zlab=list(expression(E~"("~theta~"|"~y~")"), rot=90), 
     split=c(1,1,2,2), more=TRUE)

plot(sop1, bnd=cmfit2, zlim=zlim, xlim=xlim, ylim=ylim, main="Scenario 2", 
     xlab=expression(alpha), ylab=expression(beta), 
     zlab=list(expression(E~"("~theta~"|"~y~")"), rot=90), 
     split=c(2,1,2,2), more=TRUE)

plot(sop1, bnd=cmfit3, zlim=zlim, xlim=xlim, ylim=ylim, main="Scenario 3", 
     xlab=expression(alpha), ylab=expression(beta), 
     zlab=list(expression(E~"("~theta~"|"~y~")"), rot=90), 
     split=c(1,2,2,2), more=TRUE)

plot(sop1, bnd=cmfit4, zlim=zlim, xlim=xlim, ylim=ylim, main="Scenario 4", 
     xlab=expression(alpha), ylab=expression(beta), 
     zlab=list(expression(E~"("~theta~"|"~y~")"), rot=90), 
     split=c(2,2,2,2), more=TRUE)
}

