## 2013-NOV-09
## lg_Dn.R

rm(list=ls())
options(warn=2)
library(ipeglim)

set.seed(18372342)
y <- rvg4yx(N=20, pars=2, ztrunc=FALSE, xreg=FALSE, kind="poisson")$y
m2fit <- model(formula=y~0, ztrunc=FALSE, dist="poisson", verbose=FALSE)

# scenarios
lc1 <- list(lhs=rbind(diag(rep(1,2)), diag(rep(-1,2))), rhs=c(0,0,-10,-10))
lc2 <- list(lhs=rbind(diag(rep(1,2)), diag(rep(-1,2)), c(-1,1)), rhs=c(1,1,-8,-8,-4))
lc3 <- list(lhs=rbind(c(1,1), c(-1,-1), c(-1,1), c(1,-1), c(0,-1), c(0,1)), rhs=c(3,-7,-3,-1,-3,1)*2)
lc4 <- list(x=5,y=5,r=5,len=25)

cmfit1 <- iprior(obj=m2fit, eqns=lc1, verbose=FALSE)
cmfit2 <- iprior(obj=m2fit, eqns=lc2, verbose=FALSE)
cmfit3 <- iprior(obj=m2fit, eqns=lc3, verbose=FALSE)
cmfit4 <- iprior(obj=m2fit, circle=lc4, verboser=FALSE)

# par(mfrow=c(2,2), mar=c(2,3,2,1))
par(mfrow=c(2,2), mar=c(4,4,0,0))
xylim <- c(0,11)
plot(cmfit1, xlim=xylim, ylim=xylim, xlab=expression(alpha), ylab=expression(beta))
plot(cmfit2, xlim=xylim, ylim=xylim, xlab=expression(alpha), ylab=expression(beta))
plot(cmfit3, xlim=xylim, ylim=xylim, xlab=expression(alpha), ylab=expression(beta))
plot(cmfit4, xlim=xylim, ylim=xylim, xlab=expression(alpha), ylab=expression(beta))

